/*  WinUtilities.c
 *
 *	03Jan2014  Alex Hunter  1. Added PISetRect32.
 */


#include <windowsx.h>
#include <string.h>
#include "PITypes.h"

#define signatureSize	4
static char cSig[signatureSize] = {'O', 'T', 'O', 'F'};

static short memError;


Handle NewHandle (long size)
{
	Handle mHand;
	char *p;

	memError = noErr;

	mHand =	(Handle) GlobalAllocPtr (GHND, (sizeof (Handle) + signatureSize));

	if (mHand)
		*mHand = (Ptr) GlobalAllocPtr (GHND, size);

	if (!mHand || !(*mHand))
		{
		memError = memFullErr;
		return NULL;
		}

	// put the signature after the pointer
	p = (char *) mHand;
	p += sizeof (Handle);
	memcpy (p,cSig, signatureSize);

	return mHand;
		
}

long GetHandleSize(Handle handle)
{
	Ptr p;
	HANDLE h;

	memError = noErr;

	if (handle)
		{
		p = *handle;

		h = GlobalPtrHandle (p);

		if (h)

			return (long)GlobalSize (h);
		}

	memError = nilHandleErr;

	return 0L;

}

void SetHandleSize (Handle handle, long newSize)
{
	Ptr p;

	memError = noErr;

	if (handle)
		{
		p = *handle;

		if (p)

			GlobalReAllocPtr(p, newSize, GHND);


		if (p)

			*handle = p;
		else

			memError = memFullErr;
		}

	else

		memError = memWZErr;

}

void DisposHandle (Handle handle)
{

	memError = noErr;

	if (handle)
		{
		Ptr p;

		p = *handle;

		if (p)
			GlobalFreePtr (p);

		GlobalFreePtr ((Ptr)handle);
		}

	else

		memError = nilHandleErr;
}

void HLock (Handle h)
{

}

void HUnlock (Handle h)
{

}

void MoveHHi (Handle h)
{

}

Ptr NewPtr (long size)
{
	return GlobalAllocPtr(GHND, size);
}

void DisposPtr (Ptr p)
{
	if (p)
		GlobalFreePtr (p);
}


OSErr MemError(void)
{
  return memError;
}

void PISetRect (Rect *rect, short left, short top, short right, short bottom)
{
	rect->left = left;
	rect->top = top;
	rect->right = right;
	rect->bottom = bottom;
}

void PISetRect32 (VRect *rect, int left, int top, int right, int bottom)
{
	rect->left = left;
	rect->top = top;
	rect->right = right;
	rect->bottom = bottom;
}


