/****************************** MD386MSG.H *******************************/
/*                                                                       */
/*  Message definitions for FM.                                          */
/*                                                                       */
/*  16Jan98  Alex Hunter  1. Derived from the MD386 version.             */
/*  08Jun14  Alex Hunter  1. Add !U* directives to NYI.					 */
/*                                                                       */
/*  -- should probably get these strings from a string resource table!   */
/*                                                                       */
/*************************************************************************/

#ifdef WIN32
 
/*
!  General messages.
*/
 
MD386__NYI, "NYI",	"this feature is not yet implemented !U* !U* !U*",
MD386__BUG1, "BUG1",	"bug in FM",
MD386__BUG, "BUG",	"bug number !UL in FM module !AD",
 
/*
!  MDD messages.
*/
#if 1
MD386__DICTOVFL, "DICTOVFL",  "too many symbols in program",
MD386__SORTOVFL, "SORTOVFL",  "too many symbols to sort (max is !UL)",
MD386__SORTING, "SORTING",	"sorting !UL symbols...",
MD386__TYPOVFL, "TYPOVFL",	"too many type definitions (max is !UL)",
MD386__PUBOVFL, "PUBOVFL",	"too many public symbols (max is !UL)",
#endif
MD386__ARGOVFL, "ARGOVFL",	"too many arguments (max is !UL)",
MD386__NARGS, "NARGS",  "incorrect number of arguments in function call (!SL instead of !SL)",

/*
!  MDE messages.
*/

MD386__CTRLC, "CTRLC",	"operation aborted",
MD386__USERCAN, "USERCAN", "operation canceled by user",
 
/*
!  MDL messages.
*/
 
 
/*
!  MDM messages.
*/
#if 1
MD386__LINETOOLONG, "LINETOOLONG", "expanded input line is too long",
#endif

/*
! MDO messages.
*/
#if 1
MD386__LOGFILERR, "LOGFILERR",	"error opening or closing log file !AS",
#endif

/*
!  MDP messages.
*/
#if 1
MD386__SYNTAX, "SYNTAX",	"command syntax error at or near '!AS'",
MD386__NEEDMORE, "NEEDMORE",	"unexpected end of command line",
MD386__PARSEROVFL, "PARSEROVFL", "source code too complex for parser",
MD386__CMDTOOLONG, "CMDTOOLONG", "command too long (more than !UL characters)",
MD386__CMDSYNTAX, "CMDSYNTAX",  "error while parsing !AZ, near '!AZ'",
#endif

/*
!  MDQ messages.
*/
#if 1
MD386__FILNOTFOU, "FILNOTFOU",	"file not found",
MD386__EOF, "EOF",	"end of file",
#endif

/*
!  MDS messages.
*/
#if 0
MD386__SRCOVFL, "SRCOVFL",	"source table overflow while reading module !AC",
MD386__GOTSRC, "GOTSRC",	"source obtained for module !AC",
MD386__DUPSRC, "DUPSRC",	"already have source for module !AC (this source ignored)",
MD386__IGNSRC, "IGNSRC",	"source ignored for module !AC",
MD386__BADSRCLANG, "BADSRCLANG",	"module !AC not C-386 or FORTRAN-386 output",
MD386__TOOMANYSRC, "TOOMANYSRC", "too many source files (while opening !AC)",
MD386__NOSRCFND, "NOSRCFND",	"no source modules found in file !AC",
MD386__NOSRCLIN, "NOSRCLIN",   "requested source line(s) not available",
MD386__DIFSRCMOD, "DIFSRCMOD", "requested source lines are not in same module",
MD386__NULSRCRNG, "NULSRCRNG",	"void range",
#endif

/*
!  MDT messages.
*/
#if 0
MD386__TASKALRDYBROKEN, "TASKALRDYBROKEN", "task is already broken",
MD386__NOTASK, "NOTASK",	"no current task - use SET TASK",
MD386__TASKREGS, "TASKREGS",	"registers not accessible -- no current task",
#endif

/*
!  MDV messages.
*/
#if 0
MD386__DEPOSIT, "DEPOSIT",	"!UL bytes deposited at location !XW:!XW",
MD386__TOOMANYSEGS, "TOOMANYSEGS", "too many memory segments",
MD386__NOSUCHSEG, "NOSUCHSEG", "attempt to examine nonexistent memory segment",
MD386__SIMULATOR, "SIMULATOR",	"the simulator can't do that",
MD386__BKPTASK, "BKPTASK",	"new breakpoint task (token !XWH)",
MD386__NORUN, "NORUN",	"not allowed in /NORUN mode",
MD386__NOIMAGE, "NOIMAGE",	"only allowed in /IMAGE mode",
MD386__TASKNOTBROKEN, "TASKNOTBROKEN", "not a broken task",
MD386__TASKNOTFOUND, "TASKNOTFOUND",  "no such task",
MD386__DUPBKPT, "DUPBKPT",	    "duplicate breakpoint",
MD386__BKPTNOTFOUND, "BKPTNOTFOUND",  "no such breakpoint",
MD386__MAXWATCH, "MAXWATCH",	    "too many watchpoints",
MD386__NYIREMOTE, "NYIREMOTE",	    "not yet implemented in remote",
MD386__ILLWATLEN, "ILLWATLEN",	"size of a watchpoint must be 1, 2, or 4 bytes",
MD386__UNEXPMSG, "UNEXPMSG",	"unexpected message from remote, type !XBH",
#endif

/*
!  MDX messages.
*/
#if 0
MD386__NOMODULES, "NOMODULES",	"no modules",
MD386__NOSUCHMOD, "NOSUCHMOD",	"module '!AS' is not in the symbol table",
MD386__NOPROG, "NOPROG",	"no program",
MD386__CONFLOPTS, "CONFLOPTS", "conflicting options specified",
MD386__NOREGBRK, "NOREGBRK",	"breakpoint cannot be a register",
MD386__NOREGTRA, "NOREGTRA",	"tracepoint cannot be a register",
MD386__ILLADREXP, "ILLADREXP",	"illegal address expression",
MD386__DEPOLEN, "DEPOLEN",   "data to be deposited exceeds !UL bytes",
MD386__BADTYPE, "BADTYPE",	"illegal data type",
MD386__ALTCONST, "ALTCONST",	"attempting to alter 'constant' data",
MD386__NODEPO, "NODEPO",     "failed to deposit at location 0!XWH:0!XWH. Maybe not RAM?",
MD386__BADPTRLEN, "BADPTRLEN", "illegal pointer length (POINTER*!UL)",
MD386__BADREAL, "BADREAL",	"illegal length for real (REAL*!UL)",
MD386__BADINTGER, "BADINTGER", "illegal length for integer (INTEGER*!UL)",
MD386__BADSEL, "BADSEL",	"illegal length for selector (SELECTOR*!UL)",
MD386__UNUSEDVAL, "UNUSEDVAL",  "one or more values in the deposit list were unused",
MD386__NOTSCALAR, "NOTSCALAR",	"attempt to dereference a nonscalar data item",
MD386__BADSTOR, "BADSTOR",	"attempt to store through a non-pointer or selector",
MD386__BADPORT, "BADPORT",	"illegal I/O port number (!XLH)",
MD386__BADPORTYP, "BADPORTYP", "illegal type for I/O port number",
MD386__BADIOTYP, "BADIOTYP",	"illegal type for input/output data",
MD386__BADIMAGE, "BADIMAGE",	"bad image file (maybe wrong file type?)",
MD386__MAXDIF, "MAXDIF",	"quitting after finding !UL differences",
MD386__NODIFS, "NODIFS",	"no differences found",
MD386__DIFFS, "DIFFS",	"!UL difference!%S found",
MD386__IMGCMT, "IMGCMT",	"image file comment: !AD",
MD386__FILNAMSIZ, "FILNAMSIZ", "file name must not exceed !UL characters",
MD386__OUTPUTLOST, "OUTPUTLOST", "output being lost, both NOTERMINAL and NOLOG are in effect",
MD386__NOTSAMSEG, "NOTSAMSEG", "first address and last address are in different segments (!XWH vs !XWH)",
MD386__NULRANGE, "NULRANGE",	"null range specified",
MD386__MAXRANGE, "MAXRANGE",	"request to examine !UL bytes aborted (max is !UL)",
MD386__OLDVER, "OLDVER", 	"micro contains obsolete version of MD386; rebuild the image",
MD386__BADTCU, "BADTCU",    "invalid or no TCU statistics from micro",
MD386__PROFILE, "PROFILE",	"executing initial commands from !AS",
MD386__ILOAD, "ILOAD",	"initializing memory from image file !AS",
MD386__VERIFYICF, "VERIFYICF",	"!AC indirect command file \"!AD\"",
MD386__REGRANGE, "REGRANGE",	"ranges of registers are not supported",
MD386__RANGEMIX, "RANGEMIX",	"range cannot start or end with a register",
MD386__BADREGTYP, "BADREGTYP",	"illegal type for register !AC",
MD386__MODIFYREG, "MODIFYREG",	"not allowed to modify register !AC",
#endif
MD386__NONEXT, "NONEXT",    "the \"next\" location is not defined at this point",
MD386__NOLAST, "NOLAST",	"last cell examined (.) is undefined at this point",

/*
!  MDY messages.
*/
 
MD386__NOSYMBOL, "NOSYMBOL",	"symbol '!AC' is not in the symbol table",
#if 1
MD386__NOLABEL, "NOLABEL",    "%LABEL !UL is not in the symbol table",
MD386__NOSEG, "NOSEG",	"segment name '!AC' is not in the symbol table",
#endif
MD386__DUPSYM, "DUPSYM",      "symbol '!AZ' is already defined in this scope",

MD386__BADQUALELEM, "BADQUALELEM", "bad qualifier path element '!AC'",
MD386__SYMNOTFND, "SYMNOTFND",	"symbol '!AS' is undefined",
#if 1
MD386__LABNOTFND, "LABNOTFND",	"search for %LABEL !AD using scope failed",
MD386__LINNOTFND, "LINNOTFND",	"search for %LINE !UL using scope failed",

MD386__NOUNIQUE, "NOUNIQUE",	"symbol '!AC' is not unique",
MD386__AMBIGLAB, "AMBIGLAB",	"reference to %LABEL !AD is not unique",
MD386__AMBIGLIN, "AMBIGLIN",	"reference to %LINE !UL is not unique",
MD386__AMBIGSEG, "AMBIGSEG",   "segment name '!AC' is not unique",
MD386__AMBIGGRP, "AMBIGGRP",	"group name '!AC' is not unique",
#endif

MD386__EVALOV, "EVALOV",	"expression too complicated to evaluate",
MD386__QUALOV, "QUALOV",	"too many pathname qualifiers",
MD386__LITOV, "LITOV",	"literals too long to be evaluated",

MD386__BADMIX, "BADMIX",	"illegal mixing of operand types",
MD386__BADSUBS, "BADSUBS",    "subscript !SL is not within declared bounds of (!SL:!SL)",
MD386__NOARRAY, "NOARRAY",	"attempt to subscript a non-array",
MD386__BADMEMB, "BADMEMB",	"structure has no member .!SL",
MD386__NOSTRUC, "NOSTRUC",	"not a structure",
MD386__BADREF, "BADREF",    "attempt to dereference through a non-pointer or selector",
MD386__NOMEMB, "NOMEMB",	"structure has no member named !AC",
MD386__SELBASE, "SELBASE",	"assuming base for !AC at 0!XWH:0!XWH is of type SELECTOR...",
MD386__WORDBASE, "WORDBASE",	"assuming base for !AC at 0!XWH:0!XWH is of type WORD...",
MD386__XTRASUB, "XTRASUB",	"more than !UL subscripts specified for !UL-dimensional array",
MD386__STACKVAR, "STACKVAR",	"stack variables not accessible -- no current task",
MD386__STACKFRAME, "STACKFRAME", "stack variable not accessible -- stack frame not active",

MD386__DIVERR, "DIVERR", "divide overflow error",
MD386__DIVBYZERO, "DIVBYZERO", "attempted to divide by zero",

MD386__PTRASSN, "PTRASSN", "pointer types are not assignment-compatible",
MD386__CONSTASSN, "CONSTASSN", "assigning value to const-qualified variable",
MD386__VOIDTYPE, "VOIDTYPE", "attempt to access a void data type",
MD386__PTRDIFF, "PTRDIFF", "subtracting pointers with incompatible types",
MD386__PTRISEL, "PTRISEL", "pointers with different selectors are incommensurable",
MD386__VOIDPTR, "VOIDPTR", "operation illegal with pointer to void",
MD386__FUNCPTR, "FUNCPTR", "operation illegal with pointer to function",
MD386__NONNULLI, "NONNULLI", "operations between pointers and nonzero integers are implementation-dependent",
MD386__VOIDSUBS, "VOIDSUBS", "assuming current default type instead of void",

MD386__ILLBREAK, "ILLBREAK", "illegal break statement, not within loop or switch",
MD386__ILLCONTINUE, "ILLCONTINUE", "illegal continue statement, not within a loop statement",
MD386__ILLRETURN, "ILLRETURN", "return statement is illegal in this context",
MD386__NEEDRETVAL, "NEEDRETVAL", "expression missing in return statement",
MD386__NEEDRETURN, "NEEDRETURN", "a return statement is missing in !AZ",
MD386__ILLRGBA, "ILLRGBA", "R/G/B/A channel formula is illegal in this context",
#if 0
MD386__DLITOV, "DLITOV", "too many floating-point constants (more than !UL)",
#else
//dilute the message since dlit pool now also contains string literals...
MD386__DLITOV, "DLITOV", "too many floating-point constants or string literals",
#endif
MD386__TOOMANYCASES, "TOOMANYCASES", "more than !UL cases in a switch statement",
MD386__DUPCASE, "DUPCASE", "duplicate case value !SL in a switch statement",
MD386__BADSWITCHVAL, "BADSWITCHVAL", "switch value must be an integer expression",
MD386__BADCASEVAL, "BADCASEVAL", "case value must be a constant integer expression",
MD386__DUPDEFAULT, "DUPDEFAULT", "more than one default case in a switch statement",
MD386__ILLCASELAB, "ILLCASELAB", "illegal case label, not within a switch statement",
MD386__ILLDEFLAB, "ILLDEFLAB", "illegal default case label, not within a switch statement",
MD386__IGNLAB, "IGNLAB", "statement label ignored",

/*
!  MDZ messages.
*/
#if 1
MD386__STRUNCAT, "STRUNCAT",	"character string truncated",
MD386__ATENTRY, "ATENTRY",	"instruction counter is at procedure entry point",
MD386__PROCNOTFND, "PROCNOTFND", "cannot locate procedure containing CS:IP",
MD386__NOTSIMPLE, "NOTSIMPLE",	"symbolic address is not simple",
MD386__NONSCALAR, "NONSCALAR",	"data type must be scalar",
#endif

/*
!  80386 exception codes.
*/
#if 0
MD386__EOK, "EOK",     "E$OK - normal completion",
MD386__ETIME, "ETIME",	"E$TIME - time limit expired",
#endif
MD386__EMEM, "EMEM",	"E$MEM - insufficient memory",
#if 0
MD386__ELIMIT, "ELIMIT",	"E$LIMIT - attempt to exceed limit",
MD386__ECONTEXT, "ECONTEXT",	"E$CONTEXT - illegal context",
MD386__EEXIST, "EEXIST",	"E$EXIST - object does not exist",
MD386__ESTATE, "ESTATE",	"E$STATE - wrong state for attempted operation",
MD386__ENOTCONFIGURED, "ENOTCONFIGURED", "E$NOT$CONFIGURED - not part of this system",
MD386__ETYPE, "ETYPE",	"E$TYPE - object is not of required type",
MD386__EPARAM, "EPARAM", 	"E$PARAM - illegal value for parameter",
MD386__EUNKNOWN, "EUNKNOWN",	"unrecognized 80386 exception code",
MD386__EFEXIST, "EFEXIST",   "file already exists",
MD386__EFNEXIST, "EFNEXIST",  "can't find specified file",
MD386__ESUPPORT, "ESUPPORT",  "E$SUPPORT - operation not supported",
MD386__EFACCESS, "EFACCESS",  "file access error",
MD386__ESHARE, "ESHARE",    "file locked by another user",
MD386__ESPACE, "ESPACE",    "disk is full",
MD386__ESTRINGBUF, "ESTRINGBUF", "string is too long for buffer",
MD386__ECROSSFS, "ECROSSFS",  "can't rename file from one volume to another",
MD386__ENOPEN, "ENOPEN",    "file is not open",
MD386__EOPEN, "EOPEN",     "file is already open",
MD386__EOREAD, "EOREAD",    "file was opened for read only",
MD386__EOWRITE, "EOWRITE",   "file was opened for write only",
MD386__EPTR, "EPTR",      "bad pointer",
MD386__ESIX, "ESIX",      "too many files already open",
MD386__ESYNTAX, "ESYNTAX",   "syntax error in file name",
MD386__EUNSAT, "EUNSAT",    "object module contains unsatisfied external reference",
MD386__EADDRESS, "EADDRESS",  "object module contains illegal address",
MD386__EBADFILE, "EBADFILE",  "bad object module",
#endif

#endif