/*      **MEMBER**=NONE     */
/*      **CMS**=RMX_MD86VAX  */
/**********************************  MDG.H    ******************************/
/*                                                                         */
/*  Copyright 1997-2014 AFH Systems                                        */
/*                                                                         */
/*  FilterMeister is free software. You can redistribute and modify it     */
/*  under the terms of the MPL2 License.                                   */
/*  See: https://www.mozilla.org/en-US/MPL/2.0/                            */
/*  Any changes to the FilterMeister files have to be published or sent    */
/*  to harry@thepluginsite.com. The filter plugin code itself does not     */
/*  need to be disclosed.                                                  */
/*                                                                         */
/*    10DEC90  K. Krauter   1. upgrade to MD386.                           */
/*                             (add MDG_DWORD_TYPE_INDEX, upgrade *_STATE) */
/*    20Oct96  Alex Hunter  1. Translate to C using PLMC32.                */
/*    24Oct96  Alex Hunter  1. Merge Mdg_8087_st into Mdg_8087_state.      */
/*                          2. Mdg_task_list and Mdg_current_taskp should  */
/*                             have been external!                         */
/*                          3. Make Mdg_ctrl_c_abort volatile.             */
/*                          4. Move initialization of /MDG_OUTPUT_/        */
/*                             from MDG.H to MDG.C.                        */
/*    10Apr97  Alex Hunter  1. Correct the byte count in first byte of     */
/*                             Mdg_debugger_version_tc[].                  */
/*    12Apr97  Alex Hunter  1. Add Mdg_language.                           */
/*    19Apr97  Alex Hunter  1. Add PTR_ts typedef.                         */
/*                                                                         */
/***************************************************************************/

 extern UINT1          Mdg_prompt_tc[32];
 extern UINT1          Mdg_debugger_name_tc[];
 extern UINT1          Mdg_debugger_version_tc[13];
 extern UINT1          Mdg_microname_tc[5];
 extern UINT1          Mdg_taskname_tc[32];
 extern UINT1          Mdg_username_tc[32];
 extern UINT4          Mdg_microname;
 extern UINT1          Mdg_signonname[6];
 extern UINT2          Mdg_micro_md86_rev;
 extern UINT1          Mdg_norun_mode;
 extern UINT1          Mdg_simulator_mode;
 extern UINT1          Mdg_load_initial_image;
 extern UINT1          Mdg_initial_image_name[];
 extern STRINGDESCRIPTOR Mdg_initial_image_named;
 extern UINT1          Mdg_read_initial_commands;
 extern UINT1          Mdg_initial_command_file_specif;
 extern UINT1          Mdg_initial_command_file_name[];
 extern STRINGDESCRIPTOR Mdg_initial_command_file_named;
 extern UINT1          Mdg_mode_symbolic;
 extern UINT1          Mdg_current_mode_symbolic;
 extern UINT1          Mdg_mode_show_full;
 extern UINT1          Mdg_current_mode_show_full;
 extern UINT1          Mdg_mode_physical;
 extern UINT1          Mdg_current_mode_physical;
 extern UINT1          Mdg_mode_verify;
 extern UINT1          Mdg_current_mode_verify;
 extern UINT1          Mdg_mode_number_rep;
 extern UINT1          Mdg_current_mode_number_rep;
 extern UINT4          Mdg_input_radix;
 extern UINT4          Mdg_current_input_radix;
 extern UINT4          Mdg_output_radix;
 extern UINT4          Mdg_current_output_radix;
 extern UINT4          Mdg_max_symbolic_displacement;
 extern UINT4          Mdg_default_type_index;
 extern UINT4          Mdg_current_default_type_index;
 extern UINT4          Mdg_override_type_index;
 extern UINT4          Mdg_current_override_type_index;
 extern UINT4          Mdg_label_type_index;
 extern UINT4          Mdg_byte_type_index;
 extern UINT4          Mdg_word_type_index;
 extern UINT4          Mdg_dword_type_index;
 extern UINT2          Mdg_step_options;
 extern void           *Mdg_default_scope;
 extern UINT1          Mdg_initialize_memory;
 extern UINT1          Mdg_memory_fill_byte;
 extern UINT2          Mdg_breakpoint_task;
 extern UINT4          Mdg_max_range;
 extern UINT2          Mdg_root_job_token;
 extern INT4           Mdg_dbversion;
 extern UINT4          Mdg_language;
 extern UINT1          Mdg_load_is_in_progress;

 extern volatile UINT4 Mdg_ctrl_c_abort;

 /***common /MDG_OUTPUT_/ ***/

 extern UINT1          Mdg_output_log;
 extern UINT1          Mdg_output_terminal;
 extern UINT1          Mdg_output_verify;
 extern UINT1          Mdg_logfile_open;
 extern UINT1          Mdg_logfile_name[40];
 extern UINT4          Mdg_line_count;
 extern UINT4          Mdg_lines_per_page;
 extern UINT4          Mdg_output_page_mode;


        /***********************************************/
        /*                                             */
        /*         task regs structure                 */
        /*                                             */
        /***********************************************/

#ifdef WIN32
 /* hardware structures must be packed tightly! */
#pragma pack(push, 1)
#endif

 typedef struct
         {
             UINT4          eflags;
             UINT2          cs;
             UINT4          eip;
             UINT4          eax;
             UINT4          ecx;
             UINT4          edx;
             UINT4          ebx;
             UINT4          esp;
             UINT4          ebp;
             UINT4          esi;
             UINT4          edi;
             UINT2          ss;
             UINT2          ds;
             UINT2          es;
             UINT2          fs;
             UINT2          gs;
        }              TASKREGS;

        /***********************************************/
        /*                                             */
        /*         task ndp regs structure             */
        /*                                             */
        /***********************************************/

 typedef struct
         {
             UINT2          cw;
             UINT2          sw;
             UINT2          tag;
             UINT4          instruction;
             UINT4          operand;
             struct
             {
                 UINT1 significand[8];
                 UINT2 exponent;
             }              st[8];
         }             TASKNDP;

#ifdef WIN32
 /* restore default packing */
#pragma pack(pop)
#endif

        /***********************************************/
        /*                                             */
        /*           task state structure              */
        /*                                             */
        /***********************************************/

 typedef struct TS_tag
         {
             struct TS_tag *flink;
             struct TS_tag *blink;
             UINT2          tasktoken;
             TASKREGS       regs;
             TASKNDP        ndp;
         } TASKSTATESTRUCTURE;

        /***********************************************/
        /*                                             */
        /*         examine state                       */
        /*                                             */
        /***********************************************/

 typedef struct
         {
             UINT4         offset;
             UINT2         frame;
         } PTR_ts;

 extern TASKREGS       Mdg_examine_state;

 extern UINT1          Mdg_next_is_valid;
 extern UINT4          Mdg_next_type_index;
 extern PTR_ts         Mdg_next_cell;
 extern UINT1          Mdg_last_is_valid;
 extern UINT1          Mdg_last_is_register;
 extern UINT4          Mdg_last_type_index;
 extern PTR_ts         Mdg_last_cell;
 extern UINT1          Mdg_last_register_index;


        /************************************************/
        /*                                              */
        /*          8086 state                          */
        /*                                              */
        /************************************************/

 extern TASKREGS       Mdg_8086_state;

        /***********************************/
        /*                                 */
        /*          8087 state             */
        /*                                 */
        /***********************************/

 extern TASKNDP        Mdg_8087_state;

 extern UINT4          Mdg_gdt_base;
 extern UINT2          Mdg_gdt_limit;
 extern UINT4          Mdg_idt_base;
 extern UINT2          Mdg_idt_limit;
 extern UINT2          Mdg_initial_tss_sel;
 extern UINT2          Mdg_default_ldt_sel;

 extern TASKSTATESTRUCTURE Mdg_task_list;

 extern TASKSTATESTRUCTURE *Mdg_current_taskp;
 extern UINT2          Mdg_current_task;
 extern UINT2          Mdg_previous_task;

/************************* end of MDG.H *****************************/
